Index: /readTracFiles_mod.f90
===================================================================
--- /readTracFiles_mod.f90	(revision 1)
+++ /readTracFiles_mod.f90	(revision 2)
@@ -561,12 +564,12 @@
         ttr(it)%name = nam                                           !--- Name with possibly phase suffix
         ttr(it)%keys%name = nam                                      !--- Name inside the keys decriptor
-        ttr(it)%phas = pha(ip:ip)                                    !--- Single phase entry
-        IF(lEx.AND.tr(iq)%igen>1) THEN
-          ttr(it)%prnt = TRIM(ttr(it)%prnt)//phases_sep//pha(ip:ip)
-          ttr(it)%nam1 = TRIM(ttr(it)%nam1)//phases_sep//pha(ip:ip)
+        ttr(it)%phase = pha(ip:ip)                                   !--- Single phase entry
+        IF(lEx.AND.tr(iq)%iGeneration>1) THEN
+          ttr(it)%parent   = TRIM(ttr(it)%parent)//phases_sep//pha(ip:ip)
+          ttr(it)%gen0Name = TRIM(ttr(it)%gen0Name)//phases_sep//pha(ip:ip)
         END IF
         it=it+1
       END DO
-      IF(tr(iq)%igen==1) EXIT                                        !--- Break phase loop for gen 1
+      IF(tr(iq)%iGeneration==1) EXIT                                 !--- Break phase loop for gen 1
     END DO
   END DO
@@ -584,5 +587,5 @@
 !  * lGrowGen == F: tracer + its childs sorted by growing generation, one after the other.
 !------------------------------------------------------------------------------------------------------------------------------
-  TYPE(tra), ALLOCATABLE, INTENT(INOUT) :: tr(:)                     !--- Tracer derived type vector
+  TYPE(trac_type), ALLOCATABLE, INTENT(INOUT) :: tr(:)               !--- Tracer derived type vector
   INTEGER :: ig, ng, iq, jq, n, ix(SIZE(tr)), k
   INTEGER, ALLOCATABLE :: iy(:), iz(:)
@@ -590,7 +593,7 @@
   iq = 1
   IF(lSortByGen) THEN
-    ng = MAXVAL(tr(:)%igen, MASK=.TRUE., DIM=1)                      !--- Number of generations
+    ng = MAXVAL(tr(:)%iGeneration, MASK=.TRUE., DIM=1)               !--- Number of generations
     DO ig = 0, ng                                                    !--- Loop on generations
-      iy = PACK([(k, k=1, SIZE(tr))], MASK=tr(:)%igen==ig)           !--- Generation ig tracers indexes
+      iy = PACK([(k, k=1, SIZE(tr))], MASK=tr(:)%iGeneration==ig)    !--- Generation ig tracers indexes
       n = SIZE(iy)
       ix(iq:iq+n-1) = iy                                             !--- Stack growing generations idxs
@@ -599,11 +602,11 @@
   ELSE
     DO jq = 1, SIZE(tr,DIM=1)                                        !--- Loop on first generation tracers
-      IF(tr(jq)%igen /= 1) CYCLE                                     !--- Skip generations >= 1
+      IF(tr(jq)%iGeneration /= 1) CYCLE                              !--- Skip generations >= 1
       ix(iq) = jq                                                    !--- First generation ancestor index first
       iq = iq + 1
-      iy = strFind(tr(:)%nam1, tr(jq)%name)                          !--- Indexes of "tr(jq)" childs in "tr(:)"
-      ng = MAXVAL(tr(iy)%igen, MASK=.TRUE., DIM=1)                   !--- Generations number of the "tr(jq)" family
+      iy = strFind(tr(:)%gen0Name, tr(jq)%name)                      !--- Indexes of "tr(jq)" childs in "tr(:)"
+      ng = MAXVAL(tr(iy)%iGeneration, MASK=.TRUE., DIM=1)            !--- Generations number of the "tr(jq)" family
       DO ig = 2, ng                                                  !--- Loop   on generations for the tr(jq) family
-        iz = find(tr(iy)%igen, ig, n)                                !--- Indexes of the tracers "tr(iy(:))" of generation "ig"
+        iz = find(tr(iy)%iGeneration, ig, n)                         !--- Indexes of the tracers "tr(iy(:))" of generation "ig"
         ix(iq:iq+n-1) = iy(iz)                                       !--- Same indexes in "tr(:)"
         iq = iq + n
@@ -617,10 +620,11 @@
 !==============================================================================================================================
 LOGICAL FUNCTION mergeTracers(sections, tr) RESULT(lerr)
-  TYPE(db),  TARGET,      INTENT(IN)  :: sections(:)
-  TYPE(tra), ALLOCATABLE, INTENT(OUT) ::       tr(:)
-  TYPE(tra), POINTER     ::   t1(:),   t2(:)
-  INTEGER,  ALLOCATABLE :: ixct(:), ixck(:)
+  TYPE(dataBase_type),  TARGET, INTENT(IN)  :: sections(:)
+  TYPE(trac_type), ALLOCATABLE, INTENT(OUT) ::       tr(:)
+  TYPE(trac_type), POINTER ::   t1(:),   t2(:)
+  INTEGER,     ALLOCATABLE :: ixct(:), ixck(:)
   INTEGER :: is, k1, k2, nk2, i1, i2, nt2
-  CHARACTER(LEN=256) :: s1, v1, v2, tnam, knam
+  CHARACTER(LEN=maxlen) :: s1, v1, v2, tnam, knam, modname
+  modname = 'mergeTracers'
   lerr = .FALSE.
   t1 => sections(1)%trac(:)                                          !--- Alias: first tracers section
@@ -634,6 +638,6 @@
     tr = [tr, PACK(t2, MASK= ixct==0)]                               !--- Append with new tracers
     IF( ALL(ixct == 0) ) CYCLE                                       !--- No common tracers => done
-    CALL msg('Tracers defined in previous sections and duplicated in "'//TRIM(sections(is)%name)//'":')
-    CALL msg( t1(PACK(ixct, MASK = ixct/=0))%name, nmax=128 )        !--- Display duplicates (the 128 first at most)
+    CALL msg('Tracers defined in previous sections and duplicated in "'//TRIM(sections(is)%name)//'":', modname)
+    CALL msg(t1(PACK(ixct, MASK = ixct/=0))%name, modname, nmax=128) !--- Display duplicates (the 128 first at most)
     !--------------------------------------------------------------------------------------------------------------------------
     DO i2=1,nt2; tnam = t2(i2)%name                                  !=== LOOP ON COMMON TRACERS
@@ -644,7 +648,7 @@
       s1=' of "'//TRIM(tnam)//'" in "'//TRIM(sections(is)%name)//'" not matching previous value'
       
-      IF(test(fmsg(t1(i1)%prnt /= t2(i2)%prnt, 'Parent name'//TRIM(s1)), lerr)) RETURN
-      IF(test(fmsg(t1(i1)%type /= t2(i2)%type, 'Type'       //TRIM(s1)), lerr)) RETURN
-      IF(test(fmsg(t1(i1)%igen /= t2(i2)%igen, 'Generation' //TRIM(s1)), lerr)) RETURN
+      IF(test(fmsg('Parent name'//TRIM(s1), modname, t1(i1)%parent      /= t2(i2)%parent),      lerr)) RETURN
+      IF(test(fmsg('Type'       //TRIM(s1), modname, t1(i1)%type        /= t2(i2)%type),        lerr)) RETURN
+      IF(test(fmsg('Generation' //TRIM(s1), modname, t1(i1)%iGeneration /= t2(i2)%iGeneration), lerr)) RETURN
 
       !=== APPEND <key>=<val> PAIRS NOT PREVIOULSLY DEFINED
@@ -657,5 +661,5 @@
 
       !--- KEEP TRACK OF THE COMPONENTS NAMES
-      tr(i1)%comp = TRIM(tr(i1)%comp)//','//TRIM(tr(i2)%comp)
+      tr(i1)%component = TRIM(tr(i1)%component)//','//TRIM(tr(i2)%component)
 
       !--- SELECT COMMON TRACERS WITH DIFFERING KEYS VALUES (PREVIOUS VALUE IS KEPT)
@@ -667,5 +671,5 @@
 
       !--- DISPLAY INFORMATION: OLD VALUES ARE KEPT FOR THE KEYS FOUND IN PREVIOUS AND CURRENT SECTIONS
-      CALL msg('Key(s)'//TRIM(s1))
+      CALL msg('Key(s)'//TRIM(s1), modname)
       DO k2 = 1, nk2                                                 !--- Loop on keys found in both t1(:) and t2(:)
         knam = t2(i2)%keys%key(k2)                                   !--- Name of the current key
@@ -673,5 +677,5 @@
         IF(k1 == 0) CYCLE                                            !--- New keys are skipped
         v1 = t1(i1)%keys%val(k1); v2 = t2(i2)%keys%val(k2)           !--- Key values in t1(:) and t2(:)
-        CALL msg(' * '//TRIM(knam)//'='//TRIM(v2)//' ; previous value kept:'//TRIM(v1))
+        CALL msg(' * '//TRIM(knam)//'='//TRIM(v2)//' ; previous value kept:'//TRIM(v1), modname)
       END DO
       !------------------------------------------------------------------------------------------------------------------------
@@ -686,9 +690,9 @@
 !==============================================================================================================================
 LOGICAL FUNCTION cumulTracers(sections, tr) RESULT(lerr)
-  TYPE(db),  TARGET,      INTENT(IN)  :: sections(:)
-  TYPE(tra), ALLOCATABLE, INTENT(OUT) ::       tr(:)
-  TYPE(tra), POINTER     :: t1(:), t2(:)
+  TYPE(dataBase_type),  TARGET, INTENT(IN)  :: sections(:)
+  TYPE(trac_type), ALLOCATABLE, INTENT(OUT) ::       tr(:)
+  TYPE(trac_type), POINTER     :: t1(:), t2(:)
   INTEGER,   ALLOCATABLE :: nt(:)
-  CHARACTER(LEN=256)     :: tnam, tnam_new
+  CHARACTER(LEN=maxlen)  :: tnam, tnam_new
   INTEGER :: iq, nq, is, ns, nsec
   lerr = .FALSE.                                                     !--- Can't fail ; kept to match "mergeTracer" interface.
@@ -709,5 +713,5 @@
       ns = nt(is)                                                    !--- Number of tracers in the current section
       tr(iq + nq)%name = tnam_new                                    !--- Modify tracer name
-      WHERE(tr(1+nq:ns+nq)%prnt==tnam) tr(1+nq:ns+nq)%prnt=tnam_new  !--- Modify parent name
+      WHERE(tr(1+nq:ns+nq)%parent==tnam) tr(1+nq:ns+nq)%parent=tnam_new  !--- Modify parent name
     !--------------------------------------------------------------------------------------------------------------------------
     END DO
@@ -721,6 +725,6 @@
 !==============================================================================================================================
 SUBROUTINE setDirectKeys(tr)
-  TYPE(tra), INTENT(INOUT) :: tr(:)
-  CALL indexUpdate(tr)                                               !--- Update iparnt and idesc indexes vectors
+  TYPE(trac_type), INTENT(INOUT) :: tr(:)
+  CALL indexUpdate(tr)                                               !--- Update iqParent and iqDescen indexes vectors
 !  DO iq = 1, SIZE(tr)
 !    tr(iq)%keys%<key> = getKey_prv(it, "<key>", tr%keys,  tran0 )   !--- For additional keys
@@ -730,10 +734,9 @@
 
 !==============================================================================================================================
-LOGICAL FUNCTION dispTraSection(message, sname) RESULT(lerr)
-  CHARACTER(LEN=*), INTENT(IN) :: message
-  CHARACTER(LEN=*), INTENT(IN) :: sname
+LOGICAL FUNCTION dispTraSection(message, sname, modname) RESULT(lerr)
+  CHARACTER(LEN=*), INTENT(IN) :: message, sname, modname
   INTEGER :: idb, iq, nq
   INTEGER, ALLOCATABLE :: hadv(:), vadv(:)
-  TYPE(tra), POINTER :: tm(:)
+  TYPE(trac_type), POINTER :: tm(:)
   lerr = .FALSE.
   idb = strIdx(dBase(:)%name, sname); IF(idb == 0) RETURN
@@ -742,7 +745,7 @@
   IF(test(getKeyByName_im('hadv', hadv, tm(:)%name, tm(:)%keys),lerr)) RETURN
   IF(test(getKeyByName_im('vadv', vadv, tm(:)%name, tm(:)%keys),lerr)) RETURN
-  CALL msg(TRIM(message)//':')
+  CALL msg(TRIM(message)//':', modname)
   IF(test(dispTable('iiissis', ['iq        ','hadv      ','vadv      ','short name','parent    ','igen      ','phase     '], &
-                    cat(tm(:)%name,  tm(:)%prnt, tm(:)%phas), cat([(iq, iq=1, nq)],  hadv,  vadv, tm(:)%igen)), lerr)) RETURN
+    cat(tm(:)%name,  tm(:)%parent, tm(:)%phase), cat([(iq, iq=1, nq)],  hadv,  vadv, tm(:)%iGeneration)), lerr)) RETURN
 END FUNCTION dispTraSection
 !==============================================================================================================================
@@ -754,7 +757,7 @@
 !==============================================================================================================================
 FUNCTION aliasTracer(tname, t) RESULT(out)
-  TYPE(tra),         POINTER    :: out
-  CHARACTER(LEN=*),  INTENT(IN) :: tname
-  TYPE(tra), TARGET, INTENT(IN) :: t(:)
+  TYPE(trac_type),         POINTER    :: out
+  CHARACTER(LEN=*),        INTENT(IN) :: tname
+  TYPE(trac_type), TARGET, INTENT(IN) :: t(:)
   INTEGER :: it
   it = strIdx(t(:)%name, tname)
@@ -768,7 +771,7 @@
 !==============================================================================================================================
 FUNCTION trSubset_Indx(trac,idx) RESULT(out)
-  TYPE(tra), ALLOCATABLE             ::  out(:)
-  TYPE(tra), ALLOCATABLE, INTENT(IN) :: trac(:)
-  INTEGER,                INTENT(IN) ::  idx(:)
+  TYPE(trac_type), ALLOCATABLE             ::  out(:)
+  TYPE(trac_type), ALLOCATABLE, INTENT(IN) :: trac(:)
+  INTEGER,                      INTENT(IN) ::  idx(:)
   out = trac(idx)
   CALL indexUpdate(out)
@@ -776,7 +779,7 @@
 !------------------------------------------------------------------------------------------------------------------------------
 FUNCTION trSubset_Name(trac,nam) RESULT(out)
-  TYPE(tra), ALLOCATABLE             ::  out(:)
-  TYPE(tra), ALLOCATABLE, INTENT(IN) :: trac(:)
-  CHARACTER(LEN=*),       INTENT(IN) ::  nam(:)
+  TYPE(trac_type), ALLOCATABLE             ::  out(:)
+  TYPE(trac_type), ALLOCATABLE, INTENT(IN) :: trac(:)
+  CHARACTER(LEN=*),             INTENT(IN) ::  nam(:)
   out = trac(strIdx(trac(:)%name, nam))
   CALL indexUpdate(out)
@@ -788,30 +791,30 @@
 !=== CREATE THE SUBSET OF THE TRACERS DESCRIPTORS LIST "trac" HAVING THE FIRST GENERATION ANCESTOR NAMED "nam" ================
 !==============================================================================================================================
-FUNCTION trSubset_Nam1(trac,nam) RESULT(out)
-  TYPE(tra), ALLOCATABLE             ::  out(:)
-  TYPE(tra), ALLOCATABLE, INTENT(IN) :: trac(:)
-  CHARACTER(LEN=*),       INTENT(IN) ::  nam
-  out = trac(strFind(delPhase(trac(:)%nam1), nam))
+FUNCTION trSubset_gen0Name(trac,nam) RESULT(out)
+  TYPE(trac_type), ALLOCATABLE             ::  out(:)
+  TYPE(trac_type), ALLOCATABLE, INTENT(IN) :: trac(:)
+  CHARACTER(LEN=*),             INTENT(IN) ::  nam
+  out = trac(strFind(delPhase(trac(:)%gen0Name), nam))
   CALL indexUpdate(out)
-END FUNCTION trSubset_Nam1
-!------------------------------------------------------------------------------------------------------------------------------
-
-
-!==============================================================================================================================
-!=== UPDATE THE INDEXES iparnt(:), idesc=(:) AND igen(:) IN THE TRACERS DESCRIPTOR LIST "tr" (USEFULL FOR SUBSETS) ============
+END FUNCTION trSubset_gen0Name
+!------------------------------------------------------------------------------------------------------------------------------
+
+
+!==============================================================================================================================
+!=== UPDATE THE INDEXES iqParent, iqDescend AND iGeneration IN THE TRACERS DESCRIPTOR LIST "tr" (USEFULL FOR SUBSETS) =========
 !==============================================================================================================================
 SUBROUTINE indexUpdate(tr)
-  TYPE(tra), INTENT(INOUT) :: tr(:)
+  TYPE(trac_type), INTENT(INOUT) :: tr(:)
   INTEGER :: iq, ig, ng, ngen
   INTEGER, ALLOCATABLE :: ix(:)
-  tr(:)%iprnt = strIdx( tr(:)%name, tr(:)%prnt )                     !--- Parent index
-  ngen = MAXVAL(tr(:)%igen, MASK=.TRUE.)
+  tr(:)%iqParent = strIdx( tr(:)%name, tr(:)%parent )                !--- Parent index
+  ngen = MAXVAL(tr(:)%iGeneration, MASK=.TRUE.)
   DO iq = 1, SIZE(tr)
-    ng = tr(iq)%igen                                                 !--- Generation of the current tracer
+    ng = tr(iq)%iGeneration                                          !--- Generation of the current tracer
     ix = idxAncestor(tr, igen = ng); ix = PACK(ix, ix/=0)            !--- Indexes of the tracers with ancestor tr(iq)
     !--- Childs indexes in growing generation order
-    tr(iq)%idesc = [( PACK(ix, MASK = tr(ix)%igen == ig), ig = ng+1, ngen)]
-    tr(iq)%ndesc =     SUM(  [( COUNT(tr(ix)%igen == ig), ig = ng+1, ngen)] )
-    tr(iq)%nchld =              COUNT(tr(ix)%igen == ng+1)
+    tr(iq)%iqDescen = [( PACK(ix, MASK = tr(ix)%iGeneration == ig), ig = ng+1, ngen)]
+    tr(iq)%nqDescen =     SUM(  [( COUNT(tr(ix)%iGeneration == ig), ig = ng+1, ngen)] )
+    tr(iq)%nqChilds =              COUNT(tr(ix)%iGeneration == ng+1)
   END DO
 END SUBROUTINE indexUpdate
@@ -820,6 +823,6 @@
   
 !==============================================================================================================================
-!=== READ FILE "fnam" TO APPEND THE "dBase" TRACERS DATABASE WITH AS MUCH SECTIONS AS PARENTS NAMES IN "isot(:)%prnt":     ====
-!===  * Each section dBase(i)%name contains the isotopes "dBase(i)%trac(:)" descending on "dBase(i)%name"="iso(i)%prnt"    ====
+!=== READ FILE "fnam" TO APPEND THE "dBase" TRACERS DATABASE WITH AS MUCH SECTIONS AS PARENTS NAMES IN "isot(:)%parent":   ====
+!===  * Each section dBase(i)%name contains the isotopes "dBase(i)%trac(:)" descending on "dBase(i)%name"="iso(i)%parent"  ====
 !===  * For each isotopes class, the <key>=<val> vector of each tracer is moved into the isotopes descriptor "isot"        ====
 !=== NOTES:                                                                                                                ====
@@ -833,22 +836,23 @@
 !==============================================================================================================================
 LOGICAL FUNCTION readIsotopesFile(fnam, isot) RESULT(lerr)
-  CHARACTER(LEN=*),  INTENT(IN)    :: fnam                           !--- Input file name
-  TYPE(iso), TARGET, INTENT(INOUT) :: isot(:)                        !--- Isotopes descriptors (field "prnt" must be defined !)
+  CHARACTER(LEN=*),        INTENT(IN)    :: fnam                     !--- Input file name
+  TYPE(isot_type), TARGET, INTENT(INOUT) :: isot(:)                  !--- Isotopes descriptors (field "prnt" must be defined !)
   INTEGER :: ik, is, it, idb, nk0, i, iis
   INTEGER :: nk, ns, nt, ndb, nb0, i0
-  CHARACTER(LEN=256), POINTER     :: k(:), v(:), k0(:), v0(:)
-  CHARACTER(LEN=256), ALLOCATABLE :: vals(:)
-  CHARACTER(LEN=256)     :: val
-  TYPE(kys),    POINTER  ::   ky(:)
-  TYPE(tra),    POINTER  ::   tt(:), t
-  TYPE(db),  ALLOCATABLE ::  tdb(:)
-  LOGICAL,   ALLOCATABLE :: liso(:)
+  CHARACTER(LEN=maxlen), POINTER     :: k(:), v(:), k0(:), v0(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: vals(:)
+  CHARACTER(LEN=maxlen)              :: val, modname
+  TYPE(keys_type),           POINTER ::   ky(:)
+  TYPE(trac_type),           POINTER ::   tt(:), t
+  TYPE(dataBase_type),   ALLOCATABLE ::  tdb(:)
+  LOGICAL,               ALLOCATABLE :: liso(:)
+  modname = 'readIsotopesFile'
 
   !--- THE INPUT FILE MUST BE PRESENT
-  IF(test(fmsg(testFile(fnam),'Missing isotopes parameters file "'//TRIM(fnam)//'"'),lerr)) RETURN
+  IF(test(fmsg('Missing isotopes parameters file "'//TRIM(fnam)//'"', modname, testFile(fnam)),lerr)) RETURN
 
   !--- READ THE FILE SECTIONS, ONE EACH PARENT TRACER
   nb0 = SIZE(dBase, DIM=1)+1                                         !--- Next database element index
-  IF(test(readSections(fnam,strStack(isot(:)%prnt,',')),lerr)) RETURN!--- Read sections, one each parent tracer
+  IF(test(readSections(fnam,strStack(isot(:)%parent,',')),lerr)) RETURN !--- Read sections, one each parent tracer
   ndb = SIZE(dBase, DIM=1)                                           !--- Current database size
   DO idb = nb0, ndb
@@ -886,5 +890,5 @@
     ALLOCATE(tdb(nb0-1)); tdb(1:nb0-1)=dBase(1:nb0-1); CALL MOVE_ALLOC(FROM=tdb, TO=dBase)
   END IF
-  lerr = dispIsotopes(isot, 'Isotopes parameters read from file')
+  lerr = dispIsotopes(isot, 'Isotopes parameters read from file', modname)
 
 END FUNCTION readIsotopesFile
@@ -899,17 +903,17 @@
 !==============================================================================================================================
 SUBROUTINE initIsotopes(trac, isot)
-  TYPE(tra), ALLOCATABLE, TARGET, INTENT(INOUT) :: trac(:)
-  TYPE(iso), ALLOCATABLE, TARGET, INTENT(INOUT) :: isot(:)
-  CHARACTER(LEN=256), ALLOCATABLE :: p(:), str(:)                    !--- Temporary storage
-  CHARACTER(LEN=256) :: iname
+  TYPE(trac_type), ALLOCATABLE, TARGET, INTENT(INOUT) :: trac(:)
+  TYPE(isot_type), ALLOCATABLE, TARGET, INTENT(INOUT) :: isot(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: p(:), str(:)                 !--- Temporary storage
+  CHARACTER(LEN=maxlen) :: iname
   CHARACTER(LEN=1)   :: ph                                           !--- Phase
   INTEGER :: nbIso, ic, ip, iq, it, iz
   LOGICAL, ALLOCATABLE :: ll(:)                                      !--- Mask
-  TYPE(tra), POINTER   ::  t(:), t1
-  TYPE(iso), POINTER   ::  s
+  TYPE(trac_type), POINTER   ::  t(:), t1
+  TYPE(isot_type), POINTER   ::  s
 
   t => trac
 
-  p = PACK(delPhase(t%prnt), MASK = t%type=='tracer' .AND. t%igen==2)!--- Parents of 2nd generation isotopes
+  p = PACK(delPhase(t%parent), MASK = t%type=='tracer' .AND. t%iGeneration==2) !--- Parents of 2nd generation isotopes
   CALL strReduce(p, nbIso)
   ALLOCATE(isot(nbIso))
@@ -918,11 +922,11 @@
 
   !--- ISOTOPES RELATED VARIABLES ; NULL OR EMPTY IF NO ISOTOPES
-  isot(:)%prnt = p
+  isot(:)%parent = p
   DO ic = 1, SIZE(p)                                                 !--- Loop on isotopes classes
     s => isot(ic)
-    iname = s%prnt                                                   !--- Current isotopes class name (parent tracer name)
+    iname = s%parent                                                 !--- Current isotopes class name (parent tracer name)
 
     !=== Isotopes childs of tracer "iname": mask, names, number (same for each phase of "iname")
-    ll = t(:)%type=='tracer' .AND. delPhase(t(:)%prnt) == iname .AND. t(:)%phas == 'g'
+    ll = t(:)%type=='tracer' .AND. delPhase(t(:)%parent) == iname .AND. t(:)%phase == 'g'
     str = PACK(delPhase(t(:)%name), MASK = ll)                       !--- Effectively found isotopes of "iname"
     s%niso = SIZE(str)                                               !--- Number of "effectively found isotopes of "iname"
@@ -931,5 +935,5 @@
 
     !=== Geographic tagging tracers descending on tracer "iname": mask, names, number
-    ll = t(:)%type=='tag'    .AND. delPhase(t(:)%nam1) == iname .AND. t(:)%igen == 3
+    ll = t(:)%type=='tag'    .AND. delPhase(t(:)%gen0Name) == iname .AND. t(:)%iGeneration == 3
     s%zone = PACK(strTail(t(:)%name,'_',lFirst=.TRUE.), MASK = ll)   !--- Tagging zones names  for isotopes category "iname"
     CALL strReduce(s%zone)
@@ -946,22 +950,22 @@
 
     !=== Phases for tracer "iname"
-    s%phas = ''
-    DO ip = 1, nphases; ph = known_phases(ip:ip); IF(strIdx(t%name,addPhase(iname, ph)) /= 0) s%phas = TRIM(s%phas)//ph; END DO
-    s%npha = LEN_TRIM(s%phas)                                        !--- Equal to "nqo" for water
+    s%phase = ''
+    DO ip = 1, nphases; ph = known_phases(ip:ip); IF(strIdx(t%name,addPhase(iname, ph)) /= 0) s%phase = TRIM(s%phase)//ph; END DO
+    s%npha = LEN_TRIM(s%phase)                                        !--- Equal to "nqo" for water
 
     !=== Tables giving the index in a table of effectively found items for each dynamical tracer (1<=iq<=nqtot)
     DO iq = 1, SIZE(t)
       t1 => trac(iq)
-      IF(delPhase(t1%nam1) /= iname) CYCLE                            !--- Only deal with tracers descending on "iname"
-      t1%iso_igr = ic                                                 !--- Isotopes family       idx in list "isotopes(:)%prnt"
-      t1%iso_num = strIdx(s%trac, delPhase(strHead(t1%name,'_')))     !--- Current isotope       idx in effective isotopes list
-      t1%iso_zon = strIdx(s%zone,          strTail(t1%name,'_') )     !--- Current isotope zone  idx in effective zones    list
-      t1%iso_pha =  INDEX(s%phas,TRIM(t1%phas))                       !--- Current isotope phase idx in effective phases   list
-      IF(t1%igen /= 3) t1%iso_zon = 0                                 !--- Skip possible generation 2 tagging tracers
+      IF(delPhase(t1%gen0Name) /= iname) CYCLE                       !--- Only deal with tracers descending on "iname"
+      t1%iso_iGroup = ic                                             !--- Isotopes family       idx in list "isotopes(:)%parent"
+      t1%iso_iName  = strIdx(s%trac, delPhase(strHead(t1%name,'_'))) !--- Current isotope       idx in effective isotopes list
+      t1%iso_iZone  = strIdx(s%zone,          strTail(t1%name,'_') ) !--- Current isotope zone  idx in effective zones    list
+      t1%iso_iPhase =  INDEX(s%phase,TRIM(t1%phase))                 !--- Current isotope phase idx in effective phases   list
+      IF(t1%iGeneration /= 3) t1%iso_iZone = 0                       !--- Skip possible generation 2 tagging tracers
     END DO
 
     !=== Table used to get iq (index in dyn array, size nqtot) from the isotope and phase indexes ; the full isotopes list
     !    (including tagging tracers) is sorted this way:  iso1, iso2, ..., iso1_zone1, iso2_zone1, ..., iso1_zoneN, iso2_zoneN
-    s%iTraPha = RESHAPE( [( (strIdx(t(:)%name,  addPhase(s%trac(it),s%phas(ip:ip))),     it=1, s%nitr), ip=1, s%npha)], &
+    s%iTraPha = RESHAPE( [( (strIdx(t(:)%name,  addPhase(s%trac(it),s%phase(ip:ip))),    it=1, s%nitr), ip=1, s%npha)], &
                          [s%nitr, s%npha] )
 
@@ -970,8 +974,4 @@
                          [s%nzon, s%niso] )
   END DO
-  
-  !=== Indexes, in dynamical tracers list, of the tracers transmitted to phytrac (nqtottr non-vanishing elements)
-  ll = delPhase(t%name)/='H2O' .AND. t%iso_num ==0              !--- Mask of tracers passed to the physics
-  t(:)%itr = UNPACK([(iq,iq=1,COUNT(ll))], ll, [(0, iq=1, SIZE(t))])
 
   !=== READ PHYSICAL PARAMETERS FROM "isotopes_params.def" FILE
@@ -984,11 +984,12 @@
 
 !==============================================================================================================================
-LOGICAL FUNCTION dispIsotopes(ides, message) RESULT(lerr)
-  TYPE(iso),        INTENT(IN) :: ides(:)                            !--- Isotopes descriptor vector
+LOGICAL FUNCTION dispIsotopes(ides, message, modname) RESULT(lerr)
+  TYPE(isot_type),  INTENT(IN) :: ides(:)                            !--- Isotopes descriptor vector
   CHARACTER(LEN=*), INTENT(IN) :: message                            !--- Message to display
+  CHARACTER(LEN=*), INTENT(IN) :: modname                            !--- Calling subroutine name
   INTEGER :: ik, nk, ip, it, nt
-  CHARACTER(LEN=256) :: prf
-  CHARACTER(LEN=256), ALLOCATABLE :: ttl(:), val(:,:)
-  CALL msg(TRIM(message)//':')
+  CHARACTER(LEN=maxlen) :: prf
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: ttl(:), val(:,:)
+  CALL msg(TRIM(message)//':', modname)
   DO ip = 1, SIZE(ides)                                              !--- Loop on parents tracers
     nk = SIZE(ides(ip)%keys(1)%key)                                  !--- Same keys for each isotope
@@ -1003,5 +1004,6 @@
       END DO
     END DO
-    IF(test(fmsg(dispTable(prf, ttl, val, cat([(it,it=1,nt)]), rFmt='(EN8.4)'),'Problem with the table content'), lerr)) RETURN
+    IF(test(fmsg('Problem with the table content', modname, dispTable(prf, ttl, val, cat([(it,it=1,nt)]), rFmt='(EN8.4)')), &
+       lerr)) RETURN
     DEALLOCATE(ttl, val)
   END DO        
@@ -1016,7 +1018,7 @@
 !------------------------------------------------------------------------------------------------------------------------------
   CHARACTER(LEN=*),  INTENT(IN)    :: key, val
-  TYPE(kys),         INTENT(INOUT) :: ky
+  TYPE(keys_type),   INTENT(INOUT) :: ky
   LOGICAL, OPTIONAL, INTENT(IN)    :: lOverWrite
-  CHARACTER(LEN=256),  ALLOCATABLE :: k(:), v(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: k(:), v(:)
   INTEGER :: iky, nky
   LOGICAL :: lo
@@ -1037,5 +1039,5 @@
 !------------------------------------------------------------------------------------------------------------------------------
   CHARACTER(LEN=*),  INTENT(IN)    :: key, val
-  TYPE(kys),         INTENT(INOUT) :: ky(:)
+  TYPE(keys_type),   INTENT(INOUT) :: ky(:)
   LOGICAL, OPTIONAL, INTENT(IN)    :: lOverWrite
   INTEGER :: itr
@@ -1050,8 +1052,8 @@
 ! Purpose: The values of the keys of the tracer named "tr0" are overwritten by the values found in the *.def files, if any.
 !------------------------------------------------------------------------------------------------------------------------------
-  TYPE(tra), ALLOCATABLE, INTENT(INOUT) :: t(:)
-  CHARACTER(LEN=*),       INTENT(IN)    :: tr0
-  CHARACTER(LEN=256) :: val
-  INTEGER            :: ik, jd
+  TYPE(trac_type), ALLOCATABLE, INTENT(INOUT) :: t(:)
+  CHARACTER(LEN=*),             INTENT(IN)    :: tr0
+  CHARACTER(LEN=maxlen) :: val
+  INTEGER               :: ik, jd
   jd = strIdx(t%name, tr0)
   IF(jd == 0) RETURN
@@ -1069,7 +1071,7 @@
   INTEGER,          INTENT(IN)    :: itr
   CHARACTER(LEN=*), INTENT(IN)    :: keyn(:)
-  TYPE(tra),        INTENT(INOUT) :: ky(:)
-  CHARACTER(LEN=256), ALLOCATABLE :: k(:), v(:)
-  LOGICAL,  ALLOCATABLE :: ll(:)
+  TYPE(trac_type),  INTENT(INOUT) :: ky(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: k(:), v(:)
+  LOGICAL,               ALLOCATABLE :: ll(:)
   INTEGER :: iky
 !------------------------------------------------------------------------------------------------------------------------------
@@ -1086,5 +1088,5 @@
 !------------------------------------------------------------------------------------------------------------------------------
   CHARACTER(LEN=*), INTENT(IN)    :: keyn(:)
-  TYPE(tra),        INTENT(INOUT) :: ky(:)
+  TYPE(trac_type),  INTENT(INOUT) :: ky(:)
   INTEGER :: iky
 !------------------------------------------------------------------------------------------------------------------------------
@@ -1100,11 +1102,11 @@
 !==============================================================================================================================
 SUBROUTINE getKey_init(tracers_, isotopes_)
-  TYPE(tra), OPTIONAL, INTENT(IN) ::  tracers_(:)
-  TYPE(iso), OPTIONAL, INTENT(IN) :: isotopes_(:)
+  TYPE(trac_type), OPTIONAL, INTENT(IN) ::  tracers_(:)
+  TYPE(isot_type), OPTIONAL, INTENT(IN) :: isotopes_(:)
   IF(PRESENT( tracers_))  tracers =  tracers_
   IF(PRESENT(isotopes_)) isotopes = isotopes_
 END SUBROUTINE getKey_init
 !==============================================================================================================================
-CHARACTER(LEN=256) FUNCTION fgetKey(itr, keyn, ky, def_val) RESULT(out)
+CHARACTER(LEN=maxlen) FUNCTION fgetKey(itr, keyn, ky, def_val) RESULT(out)
 !------------------------------------------------------------------------------------------------------------------------------
 ! Purpose: Internal function ; get a key value in string format (this is the returned argument).
@@ -1112,5 +1114,5 @@
   INTEGER,                    INTENT(IN) :: itr
   CHARACTER(LEN=*),           INTENT(IN) :: keyn
-  TYPE(kys),                  INTENT(IN) :: ky(:)
+  TYPE(keys_type),            INTENT(IN) :: ky(:)
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: def_val
 !------------------------------------------------------------------------------------------------------------------------------
@@ -1126,8 +1128,8 @@
   !     * "ky"   specified: try in "ky"      for "tnam" with phase and tagging suffixes, then without.
   !    The returned error code is always .FALSE.: an empty string is returned when the key hasn't been found.
-  CHARACTER(LEN=*),    INTENT(IN)  :: keyn
-  CHARACTER(LEN=256),  INTENT(OUT) :: val
-  CHARACTER(LEN=*),    INTENT(IN)  :: tname
-  TYPE(kys), OPTIONAL, INTENT(IN)  :: ky(:)
+  CHARACTER(LEN=*),          INTENT(IN)  :: keyn
+  CHARACTER(LEN=maxlen),     INTENT(OUT) :: val
+  CHARACTER(LEN=*),          INTENT(IN)  :: tname
+  TYPE(keys_type), OPTIONAL, INTENT(IN)  :: ky(:)
   INTEGER :: is
   lerr = .FALSE.
@@ -1147,8 +1149,8 @@
 
 FUNCTION getKeyByName_prv(keyn, tname, ky) RESULT(val)
-  CHARACTER(LEN=256)            :: val
+  CHARACTER(LEN=maxlen)         :: val
   CHARACTER(LEN=*), INTENT(IN)  :: keyn
   CHARACTER(LEN=*), INTENT(IN)  :: tname
-  TYPE(kys),        INTENT(IN)  :: ky(:)
+  TYPE(keys_type),  INTENT(IN)  :: ky(:)
   INTEGER :: itr, iky
   val = ''; iky = 0
